#include "Model_bs.h"

Model_bs::Model_bs() {
	state.push_back(-89.9863526453 ); // Voltage
	state.push_back( 0 ); // d_gate
	state.push_back( 0.9998361223 ); // f_gate
	state.push_back( 0.00010819 ); // X_r
	state.push_back( 0.0113541899 ); // Ca_i
	state.push_back( 12.6287781918 ); // Na_i
	state.push_back( 143.9032192933 ); // K_i
	state.push_back( 7.1976768273 ); // Ca_JSR
	state.push_back( 1.1992257705 ); // Ca_NSR
	state.push_back( 0.0041593655 ); // X_s
	state.push_back( 0.000879064 ); // b_gate
	state.push_back( 0.9952963692 ); // g_gate
	state.push_back( 0.0041593655 ); // X_s2
	state.push_back( 7.9050503334599447068e-323 ); // I_rel
	state.push_back( 0.9999848527 ); // y_gate
	state.push_back( 0.0108622692 ); // z_gate
	state.push_back( 0.2647239905 ); // markov 1-13
	state.push_back( 0.0029986711 );
	state.push_back( 1.26611666411852E-05 );
	state.push_back( 3.10466004246949E-06 );
	state.push_back( 4.35027112113673E-08 );
	state.push_back( 0.7239492459 );
	state.push_back( 0.0082005628 );
	state.push_back( 3.46249012981194E-05 );
	state.push_back( 2.33634992229991E-08 );
	state.push_back( 7.62051838475029E-05 );
	state.push_back( 8.63217135543962E-07 );
	state.push_back( 3.64472645555614E-09 );
	state.push_back( 2.45931569494852E-12 );
}

unsigned int Model_bs::get_N_states() {
	return 29;
}

void Model_bs::rhs(const state_type &x, state_type &dxdt, const double t) {
	dxdt[0] = I_stim - 0.00121905041183449*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.000348558117754157*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 3.90096131787036*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 0.007016*x[0] - 0.05*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) - x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 1.1*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 0.0238624460886417*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - (0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - (x[0] - 26.7123387054983*log(140/x[5]))*(23.5*x[24] + 23.5*x[28]) - 0.698346260819087*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.106849354821993*log(140/x[5]) + 0.0402822067678914*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - (0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) - 0.00025*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 1.6875/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[1] = 1.0*(0.035*x[0] + 0.35)*(-x[1] + 1.0/((0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)*(exp(-41.6666666666667*x[0] - 2500.0) + 1)))*(0.201379497744924*exp(-0.16025641025641*x[0]) + 1.0)/(-0.201379497744924*exp(-0.16025641025641*x[0]) + 1);
	dxdt[2] = (0.02 + 0.0197*exp(-pow(0.0337*x[0] + 0.337, 2.0)))*(-x[2] + 1.0/(exp((1.0L/8.0L)*x[0] + 4) + 1) + 0.6/(exp(-1.0L/20.0L*x[0] + 5.0L/2.0L) + 1));
	dxdt[3] = (-x[3] + 1.0/(0.0568882383461015*exp(-0.133333333333333*x[0]) + 1))*((0.00061*x[0] + 0.023729)/(281.603485023222*exp(0.145*x[0]) - 1) + (0.00138*x[0] + 0.019596)/(-0.174365780410873*exp(-0.123*x[0]) + 1));
	dxdt[4] = -0.000119995019115385*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 9.27732802666124e-8*x[0] - 1.53801857205922e-6*pow(x[10], 2)*x[11]*(x[0] - 13.3561693527491*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096))) + 0.00705882352941176*x[13] + 4.73529411764706e-5*x[8] - 0.0811764705882352*(0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) + 1.23909564265093e-6*log(1.8/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)) - 3.07603714411845e-5*(0.383333333333333*x[4] + 0.766666666666667*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.047104)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04046) + 1.53801857205922e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1);
	dxdt[5] = -7.49968869471155e-8*x[0]*x[1]*x[2]*(0.75*x[5]*exp(0.0374358835078026*x[0]) - 105.0)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 2.46082971529476e-7*x[0] - 6.1520742882369e-5*(x[0] - 26.7123387054983*log(140/x[5]))*(23.5*x[24] + 23.5*x[28]) + 6.57345168515085e-6*log(140/x[5]) - 4.61405571617767e-8*(-2744000.0L/3.0L*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) - 5488000.0L/3.0L*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) + 112394.24)*exp(-0.0318205009816322*x[0])/(0.0001*((2744000.0L/3.0L)*x[4] + 1.8*pow(x[5], 3)*exp(0.0374358835078026*x[0]) + (5488000.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 112394.24)*exp(-0.0318205009816322*x[0]) + 1) - 0.000311448760841993/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[6] = 6.1520742882369e-5*I_stim - 2.1443554341916e-8*x[0]*x[1]*x[2]*(0.75*x[6]*exp(0.0374358835078026*x[0]) - 3.375)/((exp(0.0374358835078026*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - 6.1520742882369e-5*x[12]*x[9]*(0.433 + 0.2598/(6.48182102606265e-7*pow(1.0/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096), 1.4) + 1))*(x[0] - 26.7123387054983*log(7.0662/(0.01833*x[5] + x[6]))) - 6.76728171706059e-5*x[14]*pow(x[15], 3)*(x[0] - 26.7123387054983*log(4.5/x[6]))*exp(0.01*x[0]) - 1.46803541036372e-6*x[3]*(x[0] - 26.7123387054983*log(4.5/x[6]))/(1.49449105027909*exp(0.0446428571428571*x[0]) + 1.0) - 6.1520742882369e-5*(0.00552*x[0] - 0.14745210965435*log(4.5/x[6]))/(3.49793891302524*exp(-0.167224080267559*x[0]) + 1) - 4.29627807547148e-5*(x[0] - 26.7123387054983*log(4.5/x[6]))/(((0.0302566005849132*pow(1.0/x[6], -2.14553504482562)*exp(0.08032*x[0]) + 9.64976139044134e-18*pow(1.0/x[6], -1.64948691506452)*exp(0.06175*x[0]))/(81717742.8102406*pow(1.0/x[6], 13.7381557962378)*exp(-0.5143*x[0]) + 1) + 1.02/(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1))*(5.07000951006702e-11*pow(1.0/x[6], -6.37089278126134)*exp(0.2385*x[0]) + 1)) + 0.000207632507227995/((1 + 100/pow(x[5], 2))*(0.0365332261305191*exp(-0.0374358835078026*x[0]) + 0.1245*exp(-0.00374358835078026*x[0]) + 1));
	dxdt[7] = -x[13] - 1.0L/240.0L*x[7] + (1.0L/120.0L)*x[8] - 1.0L/240.0L*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + 0.045;
	dxdt[8] = 0.00036231884057971*x[7] - 0.00130797101449275*x[8] + 0.00036231884057971*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) + (0.00291666666666667*x[4] + 0.00583333333333333*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.0003584)/((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04004) - 0.00391304347826087;
	dxdt[9] = (-x[9] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*((7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + (0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[10] = (-x[10] + 1.0/(0.27354304157175*exp(-0.0925925925925926*x[0]) + 1))/(3.7 + 6.1/(258.6706305155*exp(0.222222222222222*x[0]) + 1));
	dxdt[11] = (-x[11] + 1.0/(44994.057941343*exp(0.178571428571429*x[0]) + 1))/((1.0 - 1.0/(exp((-41.6666666666667)*x[0]) + 1))*(-0.875*x[0] + 12.0) + 12.0/(exp((-41.6666666666667)*x[0]) + 1));
	dxdt[12] = (-x[12] + 1.0/(1.09397774310453*exp(-0.0598802395209581*x[0]) + 1))*(0.25*(7.19e-5*x[0] + 0.002157)/(-0.0117959385197516*exp(-0.148*x[0]) + 1) + 0.25*(0.000131*x[0] + 0.00393)/(7.85381970442166*exp(0.0687*x[0]) - 1));
	dxdt[13] = (0.210526315789474 + 0.00258947368421053/((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4))*(-2.31619578248553*x[0]*x[1]*x[2]*(((1.0L/3.0L)*x[4] + (2.0L/3.0L)*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 0.04096)*exp(0.0748717670156052*x[0]) - 0.6138)/((1 + pow((1.0L/2.0L)*x[7] + (1.0L/2.0L)*sqrt(3.2*x[7] + pow(-x[7] + 10.8, 2)) - 5.4, -9))*(exp(0.0748717670156052*x[0]) - 1)*(555.555555555556*x[4] + 1111.11111111111*sqrt(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837)*cos((1.0L/3.0L)*acos((1.0L/2.0L)*(3.213e-5*x[4] + (-9*x[4] + 1.10592)*(-0.00288*x[4] + 0.00019279) - (-2*x[4] + 0.24576)*pow(-x[4] + 0.12288, 2))*pow(0.00864*x[4] + pow(-x[4] + 0.12288, 2) - 0.00057837, -1.5))) - 67.2666666666667)) - x[13]);
	dxdt[14] = -14.8413159102577*x[14]*exp(0.2*x[0])/(148.413159102577*exp(0.2*x[0]) + 1.0) + 0.015*(-x[14] + 1.0)/(162754.791419004*exp(0.2*x[0]) + 1.0);
	dxdt[15] = -0.273237224472926*x[15]*exp(-0.04*x[0])/(0.0273237224472926*exp(-0.04*x[0]) + 1.0) + 2.01896517994655*(-x[15] + 1.0)*exp(0.04*x[0])/(0.201896517994655*exp(0.04*x[0]) + 1.0);
	dxdt[16] = x[16]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[17]*exp(-0.0492610837438424*x[0]) + x[21]*(2.0e-5*x[0] + 0.0084);
	dxdt[17] = 3.802*x[16]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[17]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.1917*exp(-0.0492610837438424*x[0]) - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[18]*exp(-0.0492610837438424*x[0]) + x[22]*(2.0e-5*x[0] + 0.0084);
	dxdt[18] = 3.802*x[17]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[18]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.09178*exp(0.0336927223719677*x[0]) - 1.47053883789031e-5*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])))) + 1.51732e-7*x[19]*exp(-0.12987012987013*x[0]) + x[23]*(2.0e-5*x[0] + 0.0084) + 9.178*x[24]*exp(0.0336927223719677*x[0]);
	dxdt[19] = 0.09178*x[18]*exp(0.0336927223719677*x[0]) + x[19]*(-1.51732e-7*exp(-0.12987012987013*x[0]) - 0.000262228571428571*exp(0.0336927223719677*x[0])) + 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[20] = 0.000262228571428571*x[19]*exp(0.0336927223719677*x[0]) - 7.5866e-9*x[20]*exp(-0.12987012987013*x[0]);
	dxdt[21] = 1.51732e-7*x[16]*exp(-0.12987012987013*x[0]) + x[21]*(-2.0e-5*x[0] - 0.0084001 - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[22]*exp(-0.0492610837438424*x[0]) + 0.00095*x[25];
	dxdt[22] = 1.51732e-7*x[17]*exp(-0.12987012987013*x[0]) + 3.802*x[21]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[22]*(-2.0e-5*x[0] - 0.1917*exp(-0.0492610837438424*x[0]) - 0.0084001 - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[23]*exp(-0.0492610837438424*x[0]) + 0.00095*x[26];
	dxdt[23] = 1.51732e-7*x[18]*exp(-0.12987012987013*x[0]) + 3.802*x[22]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[23]*(-2.0e-5*x[0] - 0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.0084001 - 3.802/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 0.360048370091871*x[24]*exp(-0.0492610837438424*x[0]) + 0.00095*x[27];
	dxdt[24] = 1.47053883789031e-5*x[18]*exp(-0.0469163237543198*x[0])/((2.0e-5*x[0] + 0.0084)*(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 3.802*x[23]/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])) + x[24]*(-0.360048370091871*exp(-0.0492610837438424*x[0]) - 9.178*exp(0.0336927223719677*x[0]) - 1.0e-7) + 0.00095*x[28];
	dxdt[25] = 1.0e-7*x[21] + x[25]*(-0.00095 - 3.802/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0]))) + 0.1917*x[26]*exp(-0.0492610837438424*x[0]);
	dxdt[26] = 1.0e-7*x[22] + 3.802*x[25]/(0.1027*exp(-0.0588235294117647*x[0]) + 0.2*exp(-0.00666666666666667*x[0])) + x[26]*(-0.1917*exp(-0.0492610837438424*x[0]) - 0.00095 - 3.802/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0]))) + 0.255858046613164*x[27]*exp(-0.0492610837438424*x[0]);
	dxdt[27] = 1.0e-7*x[23] + 3.802*x[26]/(0.1027*exp(-0.0666666666666667*x[0]) + 0.23*exp(-0.00666666666666667*x[0])) + x[27]*(-0.255858046613164*exp(-0.0492610837438424*x[0]) - 0.00095 - 3.802/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0]))) + 0.360048370091871*x[28]*exp(-0.0492610837438424*x[0]);
	dxdt[28] = 1.0e-7*x[24] + 3.802*x[27]/(0.1027*exp(-0.0833333333333333*x[0]) + 0.25*exp(-0.00666666666666667*x[0])) + x[28]*(-0.360048370091871*exp(-0.0492610837438424*x[0]) - 0.00095);
}

rhs_type Model_bs::get_rhs() {
	return Model_bs::rhs;
}
